# PODNAME: Config::Model::models::Sshd
# ABSTRACT:  Configuration class Sshd

=encoding utf8

=head1 NAME

Config::Model::models::Sshd - Configuration class Sshd

=head1 DESCRIPTION

Configuration classes used by L<Config::Model>

This configuration class was generated from sshd_system documentation.
by L<parse-man.pl|https://github.com/dod38fr/config-model-openssh/contrib/parse-man.pl>


=head1 Elements

=head2 AcceptEnv

Specifies what environment variables sent by the client will be copied into the
session's L<environ(7)>. See B<SendEnv> and B<SetEnv> in ssh_config5 for how to
configure the client. The B<TERM> environment variable is always accepted
whenever the client requests a pseudo-terminal as it is required by the
protocol. Variables are specified by name, which may contain the wildcard
characters '*' and '?' Multiple environment variables may be separated by
whitespace or spread across multiple B<AcceptEnv> directives. Be warned that
some environment variables could be used to bypass restricted user
environments. For this reason, care should be taken in the use of this
directive. The default is not to accept any environment variables. I< Optional. Type list of uniline.  > 

=head2 AllowAgentForwarding

Specifies whether ssh-agent1 forwarding is permitted. The default is B<yes>
Note that disabling agent forwarding does not improve security unless users are
also denied shell access, as they can always install their own forwarders. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 AllowGroups

This keyword can be followed by a list of group name patterns, separated by
spaces. If specified, login is allowed only for users whose primary group or
supplementary group list matches one of the patterns. Only group names are
valid; a numerical group ID is not recognized. By default, login is allowed for
all groups. The allow/deny groups directives are processed in the following
order: B<DenyGroups> B<AllowGroups>

See PATTERNS in ssh_config5 for more information on patterns. This keyword may
appear multiple times in B<sshd_config> with each instance appending to the
list. I< Optional. Type list of uniline.  > 

=head2 AllowStreamLocalForwarding

Specifies whether StreamLocal (Unix-domain socket) forwarding is permitted. The
available options are B<yes> (the default) or B<all> to allow StreamLocal
forwarding, B<no> to prevent all StreamLocal forwarding, B<local> to allow
local (from the perspective of L<ssh(1)>) forwarding only or B<remote> to allow
remote forwarding only. Note that disabling StreamLocal forwarding does not
improve security unless users are also denied shell access, as they can always
install their own forwarders. I< Optional. Type enum. choice: 'all', 'local', 'no', 'remote', 'yes'.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 AllowTcpForwarding

Specifies whether TCP forwarding is permitted. The available options are B<yes>
(the default) or B<all> to allow TCP forwarding, B<no> to prevent all TCP
forwarding, B<local> to allow local (from the perspective of L<ssh(1)>)
forwarding only or B<remote> to allow remote forwarding only. Note that
disabling TCP forwarding does not improve security unless users are also denied
shell access, as they can always install their own forwarders. I< Optional. Type enum. choice: 'all', 'local', 'no', 'remote', 'yes'.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 AllowUsers

This keyword can be followed by a list of user name patterns, separated by
spaces. If specified, login is allowed only for user names that match one of
the patterns. Only user names are valid; a numerical user ID is not recognized.
By default, login is allowed for all users. If the pattern takes the form
USER@HOST then USER and HOST are separately checked, restricting logins to
particular users from particular hosts. HOST criteria may additionally contain
addresses to match in CIDR address/masklen format. The allow/deny users
directives are processed in the following order: B<DenyUsers> B<AllowUsers>

See PATTERNS in ssh_config5 for more information on patterns. This keyword may
appear multiple times in B<sshd_config> with each instance appending to the
list. I< Optional. Type list of uniline.  > 

=head2 AuthenticationMethods

Specifies the authentication methods that must be successfully completed for a
user to be granted access. This option must be followed by one or more lists of
comma-separated authentication method names, or by the single string B<any> to
indicate the default behaviour of accepting any single authentication method.
If the default is overridden, then successful authentication requires
completion of every method in at least one of these lists.

For example, Qq publickey, password publickey, keyboard-interactive would
require the user to complete public key authentication, followed by either
password or keyboard interactive authentication. Only methods that are next in
one or more lists are offered at each stage, so for this example it would not
be possible to attempt password or keyboard-interactive authentication before
public key.

For keyboard interactive authentication it is also possible to restrict
authentication to a specific device by appending a colon followed by the device
identifier B<bsdauth> or B<pam> depending on the server configuration. For
example, Qq keyboard-interactive:bsdauth would restrict keyboard interactive
authentication to the B<bsdauth> device.

If the publickey method is listed more than once, L<sshd(8)> verifies that keys
that have been used successfully are not reused for subsequent authentications.
For example, Qq publickey, publickey requires successful authentication using
two different public keys.

Note that each authentication method listed should also be explicitly enabled
in the configuration.

The available authentication methods are: Qq gssapi-with-mic , Qq hostbased ,
Qq keyboard-interactive , Qq none (used for access to password-less accounts
when B<PermitEmptyPasswords> is enabled), Qq password and Qq publickey . I< Optional. Type uniline.  > 

=head2 AuthorizedKeysCommand

Specifies a program to be used to look up the user's public keys. The program
must be owned by root, not writable by group or others and specified by an
absolute path. Arguments to B<AuthorizedKeysCommand> accept the tokens
described in the I<TOKENS> section. If no arguments are specified then the
username of the target user is used.

The program should produce on standard output zero or more lines of
authorized_keys output (see I<AUTHORIZED_KEYS> in L<sshd(8)>).
B<AuthorizedKeysCommand> is tried after the usual B<AuthorizedKeysFile> files
and will not be executed if a matching key is found there. By default, no
B<AuthorizedKeysCommand> is run. I< Optional. Type uniline.  > 

=head2 AuthorizedKeysCommandUser

Specifies the user under whose account the B<AuthorizedKeysCommand> is run. It
is recommended to use a dedicated user that has no other role on the host than
running authorized keys commands. If B<AuthorizedKeysCommand> is specified but
B<AuthorizedKeysCommandUser> is not, then L<sshd(8)> will refuse to start. I< Optional. Type uniline.  > 

=head2 AuthorizedKeysFile

Specifies the file that contains the public keys used for user authentication.
The format is described in the AUTHORIZED_KEYS FILE FORMAT section of
L<sshd(8)>. Arguments to B<AuthorizedKeysFile> accept the tokens described in
the I<TOKENS> section. After expansion, B<AuthorizedKeysFile> is taken to be an
absolute path or one relative to the user's home directory. Multiple files may
be listed, separated by whitespace. Alternately this option may be set to
B<none> to skip checking for user keys in files. The default is Qq
.ssh/authorized_keys .ssh/authorized_keys2 . I< Optional. Type list of uniline.  > 

Note: AuthorizedKeysFile values are migrated from '- AuthorizedKeysFile2'

=head2 AuthorizedPrincipalsCommand

Specifies a program to be used to generate the list of allowed certificate
principals as per B<AuthorizedPrincipalsFile> The program must be owned by
root, not writable by group or others and specified by an absolute path.
Arguments to B<AuthorizedPrincipalsCommand> accept the tokens described in the
I<TOKENS> section. If no arguments are specified then the username of the
target user is used.

The program should produce on standard output zero or more lines of
B<AuthorizedPrincipalsFile> output. If either B<AuthorizedPrincipalsCommand> or
B<AuthorizedPrincipalsFile> is specified, then certificates offered by the
client for authentication must contain a principal that is listed. By default,
no B<AuthorizedPrincipalsCommand> is run. I< Optional. Type uniline.  > 

=head2 AuthorizedPrincipalsCommandUser

Specifies the user under whose account the B<AuthorizedPrincipalsCommand> is
run. It is recommended to use a dedicated user that has no other role on the
host than running authorized principals commands. If
B<AuthorizedPrincipalsCommand> is specified but
B<AuthorizedPrincipalsCommandUser> is not, then L<sshd(8)> will refuse to
start. I< Optional. Type uniline.  > 

=head2 AuthorizedPrincipalsFile

Specifies a file that lists principal names that are accepted for certificate
authentication. When using certificates signed by a key listed in
B<TrustedUserCAKeys> this file lists names, one of which must appear in the
certificate for it to be accepted for authentication. Names are listed one per
line preceded by key options (as described in I<AUTHORIZED_KEYS FILE FORMAT> in
L<sshd(8)>). Empty lines and comments starting with '#' are ignored.

Arguments to B<AuthorizedPrincipalsFile> accept the tokens described in the
I<TOKENS> section. After expansion, B<AuthorizedPrincipalsFile> is taken to be
an absolute path or one relative to the user's home directory. The default is
B<none> i.e. not to use a principals file - in this case, the username of the
user must appear in a certificate's principals list for it to be accepted.

Note that B<AuthorizedPrincipalsFile> is only used when authentication proceeds
using a CA listed in B<TrustedUserCAKeys> and is not consulted for
certification authorities trusted via ~/.ssh/authorized_keys though the
B<principals=> key option offers a similar facility (see L<sshd(8)> for
details). I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

none

=back



=head2 Banner

The contents of the specified file are sent to the remote user before
authentication is allowed. If the argument is B<none> then no banner is
displayed. By default, no banner is displayed. I< Optional. Type uniline.  > 

=head2 CASignatureAlgorithms

Specifies which algorithms are allowed for signing of certificates by
certificate authorities (CAs). The default is: ssh-ed25519,
ecdsa-sha2-nistp256, ecdsa-sha2-nistp384, ecdsa-sha2-nistp521,
sk-ssh-ed25519@openssh.com, sk-ecdsa-sha2-nistp256@openssh.com, rsa-sha2-512,
rsa-sha2-256

If the specified list begins with a '+' character, then the specified
algorithms will be appended to the default set instead of replacing them. If
the specified list begins with a '-' character, then the specified algorithms
(including wildcards) will be removed from the default set instead of replacing
them.

Certificates signed using other algorithms will not be accepted for public key
or host-based authentication. I< Optional. Type uniline.  > 

=head2 ChannelTimeout

Specifies whether and how quickly L<sshd(8)> should close inactive channels.
Timeouts are specified as one or more ''type=interval'' pairs separated by
whitespace, where the ''type'' must be the special keyword ''global'' or a
channel type name from the list below, optionally containing wildcard
characters.

The timeout value ''interval'' is specified in seconds or may use any of the
units documented in the I<TIME FORMATS> section. For example, ''session=5m''
would cause interactive sessions to terminate after five minutes of inactivity.
Specifying a zero value disables the inactivity timeout.

The special timeout ''global'' applies to all active channels, taken together.
Traffic on any active channel will reset the timeout, but when the timeout
expires then all open channels will be closed. Note that this global timeout is
not matched by wildcards and must be specified explicitly.

The available channel type names include:

B<agent-connection> Open connections to ssh-agent1. B<direct-tcpip ,
direct-streamlocal@openssh.com> Open TCP or Unix socket (respectively)
connections that have been established from a L<ssh(1)> local forwarding, i.e.
B<LocalForward> or B<DynamicForward> B<forwarded-tcpip ,
forwarded-streamlocal@openssh.com> Open TCP or Unix socket (respectively)
connections that have been established to a L<sshd(8)> listening on behalf of a
L<ssh(1)> remote forwarding, i.e. B<RemoteForward> B<session> The interactive
main session, including shell session, command execution, L<scp(1)>,
L<sftp(1)>, etc. B<tun-connection> Open B<TunnelForward> connections.
B<x11-connection> Open X11 forwarding sessions.

Note that in all the above cases, terminating an inactive session does not
guarantee to remove all resources associated with the session, e.g. shell
processes or X11 clients relating to the session may continue to execute.

Moreover, terminating an inactive channel or session does not necessarily close
the SSH connection, nor does it prevent a client from requesting another
channel of the same type. In particular, expiring an inactive forwarding
session does not prevent another identical forwarding from being subsequently
created.

The default is not to expire channels of any type for inactivity. I< Optional. Type uniline.  > 

=head2 ChrootDirectory

Specifies the pathname of a directory to L<chroot(2)> to after authentication.
At session startup L<sshd(8)> checks that all components of the pathname are
root-owned directories which are not writable by group or others. After the
chroot, L<sshd(8)> changes the working directory to the user's home directory.
Arguments to B<ChrootDirectory> accept the tokens described in the I<TOKENS>
section.

The B<ChrootDirectory> must contain the necessary files and directories to
support the user's session. For an interactive session this requires at least a
shell, typically L<sh(1)>, and basic /dev nodes such as L<null(4)>, L<zero(4)>,
L<stdin(4)>, L<stdout(4)>, L<stderr(4)>, and L<tty(4)> devices. For file
transfer sessions using SFTP no additional configuration of the environment is
necessary if the in-process sftp-server is used, though sessions which use
logging may require /dev/log inside the chroot directory on some operating
systems (see sftp-server8 for details).

For safety, it is very important that the directory hierarchy be prevented from
modification by other processes on the system (especially those outside the
jail). Misconfiguration can lead to unsafe environments which L<sshd(8)> cannot
detect.

The default is B<none> indicating not to L<chroot(2)>. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

none

=back



=head2 ClientAliveCountMax

Sets the number of client alive messages which may be sent without L<sshd(8)>
receiving any messages back from the client. If this threshold is reached while
client alive messages are being sent, sshd will disconnect the client,
terminating the session. It is important to note that the use of client alive
messages is very different from B<TCPKeepAlive> The client alive messages are
sent through the encrypted channel and therefore will not be spoofable. The TCP
keepalive option enabled by B<TCPKeepAlive> is spoofable. The client alive
mechanism is valuable when the client or server depend on knowing when a
connection has become unresponsive.

The default value is 3. If B<ClientAliveInterval> is set to 15, and
B<ClientAliveCountMax> is left at the default, unresponsive SSH clients will be
disconnected after approximately 45 seconds. Setting a zero
B<ClientAliveCountMax> disables connection termination. I< Optional. Type integer.  > 

=over 4

=item upstream_default value :

3

=back



=head2 ClientAliveInterval

Sets a timeout interval in seconds after which if no data has been received
from the client, L<sshd(8)> will send a message through the encrypted channel
to request a response from the client. The default is 0, indicating that these
messages will not be sent to the client. I< Optional. Type integer.  > 

=over 4

=item upstream_default value :

0

=back



=head2 DenyGroups

This keyword can be followed by a list of group name patterns, separated by
spaces. Login is disallowed for users whose primary group or supplementary
group list matches one of the patterns. Only group names are valid; a numerical
group ID is not recognized. By default, login is allowed for all groups. The
allow/deny groups directives are processed in the following order:
B<DenyGroups> B<AllowGroups>

See PATTERNS in ssh_config5 for more information on patterns. This keyword may
appear multiple times in B<sshd_config> with each instance appending to the
list. I< Optional. Type list of uniline.  > 

=head2 DenyUsers

This keyword can be followed by a list of user name patterns, separated by
spaces. Login is disallowed for user names that match one of the patterns. Only
user names are valid; a numerical user ID is not recognized. By default, login
is allowed for all users. If the pattern takes the form USER@HOST then USER and
HOST are separately checked, restricting logins to particular users from
particular hosts. HOST criteria may additionally contain addresses to match in
CIDR address/masklen format. The allow/deny users directives are processed in
the following order: B<DenyUsers> B<AllowUsers>

See PATTERNS in ssh_config5 for more information on patterns. This keyword may
appear multiple times in B<sshd_config> with each instance appending to the
list. I< Optional. Type list of uniline.  > 

=head2 DisableForwarding

Disables all forwarding features, including X11, ssh-agent1, TCP and
StreamLocal. This option overrides all other forwarding-related options and may
simplify restricted configurations. I< Optional. Type uniline.  > 

=head2 ExposeAuthInfo

Writes a temporary file containing a list of authentication methods and public
credentials (e.g. keys) used to authenticate the user. The location of the file
is exposed to the user session through the B<SSH_USER_AUTH> environment
variable. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 ForceCommand

Forces the execution of the command specified by B<ForceCommand> ignoring any
command supplied by the client and ~/.ssh/rc if present. The command is invoked
by using the user's login shell with the -c option. This applies to shell,
command, or subsystem execution. It is most useful inside a B<Match> block. The
command originally supplied by the client is available in the
B<SSH_ORIGINAL_COMMAND> environment variable. Specifying a command of
B<internal-sftp> will force the use of an in-process SFTP server that requires
no support files when used with B<ChrootDirectory> The default is B<none> I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

none

=back



=head2 GatewayPorts

Specifies whether remote hosts are allowed to connect to ports forwarded for
the client. By default, L<sshd(8)> binds remote port forwardings to the
loopback address. This prevents other remote hosts from connecting to forwarded
ports. B<GatewayPorts> can be used to specify that sshd should allow remote
port forwardings to bind to non-loopback addresses, thus allowing other hosts
to connect. The argument may be B<no> to force remote port forwardings to be
available to the local host only, B<yes> to force remote port forwardings to
bind to the wildcard address, or B<clientspecified> to allow the client to
select the address to which the forwarding is bound. The default is B<no> I< Optional. Type enum. choice: 'clientspecified', 'no', 'yes'.  > 

=over 4

=item upstream_default value :

no

=back



=head2 GSSAPIAuthentication

Specifies whether user authentication based on GSSAPI is allowed. The default
is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 HostbasedAcceptedAlgorithms

Specifies the signature algorithms that will be accepted for hostbased
authentication as a list of comma-separated patterns. Alternately if the
specified list begins with a '+' character, then the specified signature
algorithms will be appended to the default set instead of replacing them. If
the specified list begins with a '-' character, then the specified signature
algorithms (including wildcards) will be removed from the default set instead
of replacing them. If the specified list begins with a '^' character, then the
specified signature algorithms will be placed at the head of the default set.
The default for this option is: ssh-ed25519-cert-v01@openssh.com,
ecdsa-sha2-nistp256-cert-v01@openssh.com,
ecdsa-sha2-nistp384-cert-v01@openssh.com,
ecdsa-sha2-nistp521-cert-v01@openssh.com, sk-ssh-ed25519-cert-v01@openssh.com,
sk-ecdsa-sha2-nistp256-cert-v01@openssh.com, rsa-sha2-512-cert-v01@openssh.com,
rsa-sha2-256-cert-v01@openssh.com, ssh-ed25519, ecdsa-sha2-nistp256,
ecdsa-sha2-nistp384, ecdsa-sha2-nistp521, sk-ssh-ed25519@openssh.com,
sk-ecdsa-sha2-nistp256@openssh.com, rsa-sha2-512, rsa-sha2-256

The list of available signature algorithms may also be obtained using Qq ssh -Q
HostbasedAcceptedAlgorithms . This was formerly named
HostbasedAcceptedKeyTypes. I< Optional. Type uniline.  > 

=head2 HostbasedAuthentication

Specifies whether rhosts or /etc/hosts.equiv authentication together with
successful public key client host authentication is allowed (host-based
authentication). The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 HostbasedUsesNameFromPacketOnly

Specifies whether or not the server will attempt to perform a reverse name
lookup when matching the name in the ~/.shosts ~/.rhosts and /etc/hosts.equiv
files during B<HostbasedAuthentication> A setting of B<yes> means that
L<sshd(8)> uses the name supplied by the client rather than attempting to
resolve the name from the TCP connection itself. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 IgnoreRhosts

Specifies whether to ignore per-user .rhosts and .shosts files during
B<HostbasedAuthentication> The system-wide /etc/hosts.equiv and
/etc/ssh/shosts.equiv are still used regardless of this setting.

Accepted values are B<yes> (the default) to ignore all per-user files,
B<shosts-only> to allow the use of .shosts but to ignore .rhosts or B<no> to
allow both .shosts and rhosts. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 Include

Include the specified configuration file(s). Multiple pathnames may be
specified and each pathname may contain L<glob(7)> wildcards that will be
expanded and processed in lexical order. Files without absolute paths are
assumed to be in /etc/ssh An B<Include> directive may appear inside a B<Match>
block to perform conditional inclusion. I< Optional. Type list of uniline.  > 

=head2 IPQoS

Specifies the IPv4 type-of-service or DSCP class for the connection. Accepted
values are B<af11> B<af12> B<af13> B<af21> B<af22> B<af23> B<af31> B<af32>
B<af33> B<af41> B<af42> B<af43> B<cs0> B<cs1> B<cs2> B<cs3> B<cs4> B<cs5>
B<cs6> B<cs7> B<ef> B<le> B<lowdelay> B<throughput> B<reliability> a numeric
value, or B<none> to use the operating system default. This option may take one
or two arguments, separated by whitespace. If one argument is specified, it is
used as the packet class unconditionally. If two values are specified, the
first is automatically selected for interactive sessions and the second for
non-interactive sessions. The default is B<lowdelay> for interactive sessions
and B<throughput> for non-interactive sessions. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

af21 cs1

=back



=head2 KbdInteractiveAuthentication

Specifies whether to allow keyboard-interactive authentication. The default is
B<yes> The argument to this keyword must be B<yes> or B<no>
B<ChallengeResponseAuthentication> is a deprecated alias for this. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



Note: KbdInteractiveAuthentication is migrated with 'C<$old>' and with: 

=over

=item *

C<$old> => C<- ChallengeResponseAuthentication>

=back



=head2 KerberosAuthentication

Specifies whether the password provided by the user for
B<PasswordAuthentication> will be validated through the Kerberos KDC. To use
this option, the server needs a Kerberos servtab which allows the verification
of the KDC's identity. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 LogLevel

Gives the verbosity level that is used when logging messages from L<sshd(8)>.
The possible values are: QUIET, FATAL, ERROR, INFO, VERBOSE, DEBUG, DEBUG1,
DEBUG2, and DEBUG3. The default is INFO. DEBUG and DEBUG1 are equivalent.
DEBUG2 and DEBUG3 each specify higher levels of debugging output. Logging with
a DEBUG level violates the privacy of users and is not recommended. I< Optional. Type enum. choice: 'DEBUG', 'DEBUG1', 'DEBUG2', 'DEBUG3', 'ERROR', 'FATAL', 'INFO', 'QUIET', 'VERBOSE'.  > 

=over 4

=item upstream_default value :

INFO

=back



=head2 MaxAuthTries

Specifies the maximum number of authentication attempts permitted per
connection. Once the number of failures reaches half this value, additional
failures are logged. The default is 6. I< Optional. Type integer.  > 

=over 4

=item upstream_default value :

6

=back



=head2 MaxSessions

Specifies the maximum number of open shell, login or subsystem (e.g. sftp)
sessions permitted per network connection. Multiple sessions may be established
by clients that support connection multiplexing. Setting B<MaxSessions> to 1
will effectively disable session multiplexing, whereas setting it to 0 will
prevent all shell, login and subsystem sessions while still permitting
forwarding. The default is 10. I< Optional. Type integer.  > 

=over 4

=item upstream_default value :

10

=back



=head2 PAMServiceName

Specifies the service name used for Pluggable Authentication Modules (PAM)
authentication, authorisation and session controls when B<UsePAM> is enabled.
The default is B<sshd> I< Optional. Type uniline.  > 

=head2 PasswordAuthentication

Specifies whether password authentication is allowed. The default is B<sshd> I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

sshd

=back



=head2 PermitEmptyPasswords

When password authentication is allowed, it specifies whether the server allows
login to accounts with empty password strings. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 PermitListen

Specifies the addresses/ports on which a remote TCP port forwarding may listen.
The listen specification must be one of the following forms:

B<PermitListen> I<port> B<PermitListen> I<host : port>

Multiple permissions may be specified by separating them with whitespace. An
argument of B<any> can be used to remove all restrictions and permit any listen
requests. An argument of B<none> can be used to prohibit all listen requests.
The host name may contain wildcards as described in the PATTERNS section in
ssh_config5. The wildcard '*' can also be used in place of a port number to
allow all ports. By default all port forwarding listen requests are permitted.
Note that the B<GatewayPorts> option may further restrict which addresses may
be listened on. Note also that L<ssh(1)> will request a listen host of
''localhost'' if no listen host was specifically requested, and this name is
treated differently to explicit localhost addresses of ''127.0.0.1'' and
''::1'' I< Optional. Type list of uniline.  > 

=head2 PermitOpen

Specifies the destinations to which TCP port forwarding is permitted. The
forwarding specification must be one of the following forms:

B<PermitOpen> I<host : port> B<PermitOpen> I<IPv4_addr : port> B<PermitOpen>
I<[ IPv6_addr ] : port>

Multiple forwards may be specified by separating them with whitespace. An
argument of B<any> can be used to remove all restrictions and permit any
forwarding requests. An argument of B<none> can be used to prohibit all
forwarding requests. The wildcard '*' can be used for host or port to allow all
hosts or ports respectively. Otherwise, no pattern matching or address lookups
are performed on supplied names. By default all port forwarding requests are
permitted. I< Optional. Type list of uniline.  > 

=head2 PermitRootLogin

Specifies whether root can log in using L<ssh(1)>. The argument must be B<yes>
B<prohibit-password> B<forced-commands-only> or B<no> The default is
B<prohibit-password>

If this option is set to B<prohibit-password> (or its deprecated alias,
B<without-password )> password and keyboard-interactive authentication are
disabled for root.

If this option is set to B<forced-commands-only> root login with public key
authentication will be allowed, but only if the I<command> option has been
specified (which may be useful for taking remote backups even if root login is
normally not allowed). All other authentication methods are disabled for root.

If this option is set to B<no> root is not allowed to log in. I< Optional. Type enum. choice: 'forced-commands-only', 'no', 'prohibit-password', 'yes'.  > 

=head2 PermitTTY

Specifies whether L<pty(4)> allocation is permitted. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 PermitTunnel

Specifies whether L<tun(4)> device forwarding is allowed. The argument must be
B<yes> B<point-to-point> (layer 3), B<ethernet> (layer 2), or B<no> Specifying
B<yes> permits both B<point-to-point> and B<ethernet> The default is B<no>

Independent of this setting, the permissions of the selected L<tun(4)> device
must allow access to the user. I< Optional. Type enum. choice: 'ethernet', 'no', 'point-to-point', 'yes'.  > 

=over 4

=item upstream_default value :

no

=back



=head2 PermitUserRC

Specifies whether any ~/.ssh/rc file is executed. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 PubkeyAcceptedAlgorithms

Specifies the signature algorithms that will be accepted for public key
authentication as a list of comma-separated patterns. Alternately if the
specified list begins with a '+' character, then the specified algorithms will
be appended to the default set instead of replacing them. If the specified list
begins with a '-' character, then the specified algorithms (including
wildcards) will be removed from the default set instead of replacing them. If
the specified list begins with a '^' character, then the specified algorithms
will be placed at the head of the default set. The default for this option is:
ssh-ed25519-cert-v01@openssh.com, ecdsa-sha2-nistp256-cert-v01@openssh.com,
ecdsa-sha2-nistp384-cert-v01@openssh.com,
ecdsa-sha2-nistp521-cert-v01@openssh.com, sk-ssh-ed25519-cert-v01@openssh.com,
sk-ecdsa-sha2-nistp256-cert-v01@openssh.com, rsa-sha2-512-cert-v01@openssh.com,
rsa-sha2-256-cert-v01@openssh.com, ssh-ed25519, ecdsa-sha2-nistp256,
ecdsa-sha2-nistp384, ecdsa-sha2-nistp521, sk-ssh-ed25519@openssh.com,
sk-ecdsa-sha2-nistp256@openssh.com, rsa-sha2-512, rsa-sha2-256

The list of available signature algorithms may also be obtained using Qq ssh -Q
PubkeyAcceptedAlgorithms . I< Optional. Type uniline.  > 

=head2 PubkeyAuthOptions

Sets one or more public key authentication options. The supported keywords are:
B<none> (the default; indicating no additional options are enabled),
B<touch-required> and B<verify-required>

The B<touch-required> option causes public key authentication using a FIDO
authenticator algorithm (i.e. B<ecdsa-sk> or B<ed25519-sk> to always require
the signature to attest that a physically present user explicitly confirmed the
authentication (usually by touching the authenticator). By default, L<sshd(8)>
requires user presence unless overridden with an authorized_keys option. The
B<touch-required> flag disables this override.

The B<verify-required> option requires a FIDO key signature attest that the
user was verified, e.g. via a PIN.

Neither the B<touch-required> or B<verify-required> options have any effect for
other, non-FIDO, public key types. I< Optional. Type enum. choice: 'none', 'touch-required', 'verify-required'.  > 

=head2 PubkeyAuthentication

Specifies whether public key authentication is allowed. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 RekeyLimit

Specifies the maximum amount of data that may be transmitted or received before
the session key is renegotiated, optionally followed by a maximum amount of
time that may pass before the session key is renegotiated. The first argument
is specified in bytes and may have a suffix of 'K' 'M' or 'G' to indicate
Kilobytes, Megabytes, or Gigabytes, respectively. The default is between '1G'
and '4G' depending on the cipher. The optional second value is specified in
seconds and may use any of the units documented in the I<TIME FORMATS> section.
The default value for B<RekeyLimit> is B<default none> which means that
rekeying is performed after the cipher's default amount of data has been sent
or received and no time based rekeying is done. I< Optional. Type uniline.  > 

=head2 RevokedKeys

Specifies revoked public keys file, or B<none> to not use one. Keys listed in
this file will be refused for public key authentication. Note that if this file
is not readable, then public key authentication will be refused for all users.
Keys may be specified as a text file, listing one public key per line, or as an
OpenSSH Key Revocation List (KRL) as generated by ssh-keygen1. For more
information on KRLs, see the KEY REVOCATION LISTS section in ssh-keygen1. I< Optional. Type uniline.  > 

=head2 SetEnv

Specifies one or more environment variables to set in child sessions started by
L<sshd(8)> as ''NAME=VALUE'' The environment value may be quoted (e.g. if it
contains whitespace characters). Environment variables set by B<SetEnv>
override the default environment and any variables specified by the user via
B<AcceptEnv> or B<PermitUserEnvironment> I< Optional. Type uniline.  > 

=head2 StreamLocalBindMask

Sets the octal file creation mode mask (umask) used when creating a Unix-domain
socket file for local or remote port forwarding. This option is only used for
port forwarding to a Unix-domain socket file.

The default value is 0177, which creates a Unix-domain socket file that is
readable and writable only by the owner. Note that not all operating systems
honor the file mode on Unix-domain socket files. I< Optional. Type uniline.  > 

=head2 StreamLocalBindUnlink

Specifies whether to remove an existing Unix-domain socket file for local or
remote port forwarding before creating a new one. If the socket file already
exists and B<StreamLocalBindUnlink> is not enabled, B<sshd> will be unable to
forward the port to the Unix-domain socket file. This option is only used for
port forwarding to a Unix-domain socket file.

The argument must be B<yes> or B<no> The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 TrustedUserCAKeys

Specifies a file containing public keys of certificate authorities that are
trusted to sign user certificates for authentication, or B<none> to not use
one. Keys are listed one per line; empty lines and comments starting with '#'
are allowed. If a certificate is presented for authentication and has its
signing CA key listed in this file, then it may be used for authentication for
any user listed in the certificate's principals list. Note that certificates
that lack a list of principals will not be permitted for authentication using
B<TrustedUserCAKeys> For more details on certificates, see the CERTIFICATES
section in ssh-keygen1. I< Optional. Type uniline.  > 

=head2 UnusedConnectionTimeout

Specifies whether and how quickly L<sshd(8)> should close client connections
with no open channels. Open channels include active shell, command execution or
subsystem sessions, connected network, socket, agent or X11 forwardings.
Forwarding listeners, such as those from the L<ssh(1)> -B<R> flag, are not
considered as open channels and do not prevent the timeout. The timeout value
is specified in seconds or may use any of the units documented in the I<TIME
FORMATS> section.

Note that this timeout starts when the client connection completes user
authentication but before the client has an opportunity to open any channels.
Caution should be used when using short timeout values, as they may not provide
sufficient time for the client to request and open its channels before
terminating the connection.

The default B<none> is to never expire connections for having no open channels.
This option may be useful in conjunction with B<ChannelTimeout> I< Optional. Type uniline.  > 

=head2 X11DisplayOffset

Specifies the first display number available for L<sshd(8)>Ns's X11 forwarding.
This prevents sshd from interfering with real X11 servers. The default is 10. I< Optional. Type uniline.  > 

=head2 X11Forwarding

Specifies whether X11 forwarding is permitted. The argument must be B<yes> or
B<no> The default is B<no>

When X11 forwarding is enabled, there may be additional exposure to the server
and to client displays if the L<sshd(8)> proxy display is configured to listen
on the wildcard address (see B<X11UseLocalhost )> though this is not the
default. Additionally, the authentication spoofing and authentication data
verification and substitution occur on the client side. The security risk of
using X11 forwarding is that the client's X11 display server may be exposed to
attack when the SSH client requests forwarding (see the warnings for
B<ForwardX11> in ssh_config5). A system administrator may have a stance in
which they want to protect clients that may expose themselves to attack by
unwittingly requesting X11 forwarding, which can warrant a B<no> setting.

Note that disabling X11 forwarding does not prevent users from forwarding X11
traffic, as users can always install their own forwarders. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 X11UseLocalhost

Specifies whether L<sshd(8)> should bind the X11 forwarding server to the
loopback address or to the wildcard address. By default, sshd binds the
forwarding server to the loopback address and sets the hostname part of the
B<DISPLAY> environment variable to B<localhost> This prevents remote hosts from
connecting to the proxy display. However, some older X11 clients may not
function with this configuration. B<X11UseLocalhost> may be set to B<no> to
specify that the forwarding server should be bound to the wildcard address. The
argument must be B<yes> or B<no> The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 AuthorizedKeysFile2

This parameter is now ignored by Ssh. B<Deprecated> I< Optional. Type list of uniline.  > 

=head2 ChallengeResponseAuthentication

B<Deprecated> I< Optional. Type boolean.  > 

=head2 KeyRegenerationInterval

B<Deprecated> I< Optional. Type uniline.  > 

=head2 Protocol

B<Deprecated> I< Optional. Type uniline.  > 

=head2 RDomain

B<Deprecated> I< Optional. Type uniline.  > 

=head2 RSAAuthentication

B<Deprecated> I< Optional. Type uniline.  > 

=head2 RhostsRSAAuthentication

B<Deprecated> I< Optional. Type uniline.  > 

=head2 UsePrivilegeSeparation

B<Deprecated> I< Optional. Type uniline.  > 

=head2 AddressFamily

Specifies which address family should be used by L<sshd(8)>. Valid arguments
are B<any> (the default), B<inet> (use IPv4 only), or B<inet6> (use IPv6 only). I< Optional. Type enum. choice: 'any', 'inet', 'inet6'.  > 

=over 4

=item upstream_default value :

any

=back



=head2 Ciphers

Specifies the ciphers allowed. Multiple ciphers must be comma-separated. If the
specified list begins with a '+' character, then the specified ciphers will be
appended to the default set instead of replacing them. If the specified list
begins with a '-' character, then the specified ciphers (including wildcards)
will be removed from the default set instead of replacing them. If the
specified list begins with a '^' character, then the specified ciphers will be
placed at the head of the default set.

The supported ciphers are:

B<3des-cbc> B<aes128-cbc> B<aes192-cbc> B<aes256-cbc> B<aes128-ctr>
B<aes192-ctr> B<aes256-ctr> B<aes128-gcm@openssh.com> B<aes256-gcm@openssh.com>
B<chacha20-poly1305@openssh.com>

The default is: chacha20-poly1305@openssh.com, aes128-ctr, aes192-ctr,
aes256-ctr, aes128-gcm@openssh.com, aes256-gcm@openssh.com

The list of available ciphers may also be obtained using Qq ssh -Q cipher . I< Optional. Type uniline.  > 

=head2 Compression

Specifies whether compression is enabled after the user has authenticated
successfully. The argument must be B<yes> B<delayed> (a legacy synonym for
B<yes> or B<no> The default is B<yes> I< Optional. Type enum. choice: 'delayed', 'no', 'yes'.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 DebianBanner

Specifies whether the distribution-specified extra version suffix is included
during initial protocol handshake. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 FingerprintHash

Specifies the hash algorithm used when logging key fingerprints. Valid options
are: B<md5> and B<sha256> The default is B<sha256> I< Optional. Type enum. choice: 'md5', 'sha256'.  > 

=over 4

=item upstream_default value :

sha256

=back



=head2 GSSAPICleanupCredentials

Specifies whether to automatically destroy the user's credentials cache on
logout. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 GSSAPIKeyExchange

Specifies whether key exchange based on GSSAPI is allowed. GSSAPI key exchange
doesn't rely on ssh keys to verify host identity. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 GSSAPIStrictAcceptorCheck

Determines whether to be strict about the identity of the GSSAPI acceptor a
client authenticates against. If set to B<yes> then the client must
authenticate against the host service on the current hostname. If set to B<no>
then the client may authenticate against any service key stored in the
machine's default store. This facility is provided to assist with operation on
multi homed machines. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 GSSAPIStoreCredentialsOnRekey

Controls whether the user's GSSAPI credentials should be updated following a
successful connection rekeying. This option can be used to accepted renewed or
updated credentials from a compatible client. The default is ''no''

For this to work B<GSSAPIKeyExchange> needs to be enabled in the server and
also used by the client. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 GSSAPIKexAlgorithms

The list of key exchange algorithms that are accepted by GSSAPI key exchange.
Possible values are gss-gex-sha1-, gss-group1-sha1-, gss-group14-sha1-,
gss-group14-sha256-, gss-group16-sha512-, gss-nistp256-sha256-,
gss-curve25519-sha256-

The default is ''gss-group14-sha256-, gss-group16-sha512-,
gss-nistp256-sha256-, gss-curve25519-sha256-, gss-gex-sha1-,
gss-group14-sha1-'' This option only applies to connections using GSSAPI. I< Optional. Type uniline.  > 

=head2 HostCertificate

Specifies a file containing a public host certificate. The certificate's public
key must match a private host key already specified by B<HostKey> The default
behaviour of L<sshd(8)> is not to load any certificates. I< Optional. Type uniline.  > 

=head2 HostKey

Specifies a file containing a private host key used by SSH. The defaults are
/etc/ssh/ssh_host_ecdsa_key /etc/ssh/ssh_host_ed25519_key and
/etc/ssh/ssh_host_rsa_key

Note that L<sshd(8)> will refuse to use a file if it is group/world-accessible
and that the B<HostKeyAlgorithms> option restricts which of the keys are
actually used by L<sshd(8)>.

It is possible to have multiple host key files. It is also possible to specify
public host key files instead. In this case operations on the private key will
be delegated to an ssh-agent1. I< Optional. Type uniline.  > 

=head2 HostKeyAgent

Identifies the UNIX-domain socket used to communicate with an agent that has
access to the private host keys. If the string Qq SSH_AUTH_SOCK is specified,
the location of the socket will be read from the B<SSH_AUTH_SOCK> environment
variable. I< Optional. Type uniline.  > 

=head2 HostKeyAlgorithms

Specifies the host key signature algorithms that the server offers. The default
for this option is: ssh-ed25519-cert-v01@openssh.com,
ecdsa-sha2-nistp256-cert-v01@openssh.com,
ecdsa-sha2-nistp384-cert-v01@openssh.com,
ecdsa-sha2-nistp521-cert-v01@openssh.com, sk-ssh-ed25519-cert-v01@openssh.com,
sk-ecdsa-sha2-nistp256-cert-v01@openssh.com, rsa-sha2-512-cert-v01@openssh.com,
rsa-sha2-256-cert-v01@openssh.com, ssh-ed25519, ecdsa-sha2-nistp256,
ecdsa-sha2-nistp384, ecdsa-sha2-nistp521, sk-ssh-ed25519@openssh.com,
sk-ecdsa-sha2-nistp256@openssh.com, rsa-sha2-512, rsa-sha2-256

The list of available signature algorithms may also be obtained using Qq ssh -Q
HostKeyAlgorithms . I< Optional. Type uniline.  > 

=head2 IgnoreUserKnownHosts

Specifies whether L<sshd(8)> should ignore the user's ~/.ssh/known_hosts during
B<HostbasedAuthentication> and use only the system-wide known hosts file
/etc/ssh/ssh_known_hosts The default is ''no'' I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 KerberosGetAFSToken

If AFS is active and the user has a Kerberos 5 TGT, attempt to acquire an AFS
token before accessing the user's home directory. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 KerberosOrLocalPasswd

If password authentication through Kerberos fails then the password will be
validated via any additional local mechanism such as /etc/passwd The default is
B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 KerberosTicketCleanup

Specifies whether to automatically destroy the user's ticket cache file on
logout. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 KexAlgorithms

Specifies the permitted KEX (Key Exchange) algorithms that the server will
offer to clients. The ordering of this list is not important, as the client
specifies the preference order. Multiple algorithms must be comma-separated.

If the specified list begins with a '+' character, then the specified
algorithms will be appended to the default set instead of replacing them. If
the specified list begins with a '-' character, then the specified algorithms
(including wildcards) will be removed from the default set instead of replacing
them. If the specified list begins with a '^' character, then the specified
algorithms will be placed at the head of the default set.

The supported algorithms are:

B<curve25519-sha256> B<curve25519-sha256@libssh.org>
B<diffie-hellman-group1-sha1> B<diffie-hellman-group14-sha1>
B<diffie-hellman-group14-sha256> B<diffie-hellman-group16-sha512>
B<diffie-hellman-group18-sha512> B<diffie-hellman-group-exchange-sha1>
B<diffie-hellman-group-exchange-sha256> B<ecdh-sha2-nistp256>
B<ecdh-sha2-nistp384> B<ecdh-sha2-nistp521>
B<sntrup761x25519-sha512@openssh.com>

The default is: sntrup761x25519-sha512@openssh.com, curve25519-sha256,
curve25519-sha256@libssh.org, ecdh-sha2-nistp256, ecdh-sha2-nistp384,
ecdh-sha2-nistp521, diffie-hellman-group-exchange-sha256,
diffie-hellman-group16-sha512, diffie-hellman-group18-sha512,
diffie-hellman-group14-sha256

The list of supported key exchange algorithms may also be obtained using Qq ssh
-Q KexAlgorithms . I< Optional. Type uniline.  > 

=head2 ListenAddress

Specifies the local addresses L<sshd(8)> should listen on. The following forms
may be used:

B<ListenAddress> I<hostname | address> B<ListenAddress> I<hostname : port>
B<ListenAddress> I<IPv4_address : port> B<ListenAddress> [I<hostname | address
: port> ]

If I<port> is not specified, sshd will listen on the address and all B<Port>
options specified. The default is to listen on all local addresses. Multiple
B<ListenAddress> options are permitted. I< Optional. Type uniline.  > 

=head2 LoginGraceTime

The server disconnects after this time if the user has not successfully logged
in. If the value is 0, there is no time limit. The default is 120 seconds. I< Optional. Type uniline.  > 

=head2 LogVerbose

Specify one or more overrides to B<LogLevel> An override consists of a pattern
lists that matches the source file, function and line number to force detailed
logging for. For example, an override pattern of:
kex.c:*:1000,*:kex_exchange_identification():*, packet.c:*

would enable detailed logging for line 1000 of kex.c everything in the Fn
kex_exchange_identification function, and all code in the packet.c file. This
option is intended for debugging and no overrides are enabled by default. I< Optional. Type uniline.  > 

=head2 MACs

Specifies the available MAC (message authentication code) algorithms.

The MAC algorithm is used for data integrity protection. Multiple algorithms
must be comma-separated. If the specified list begins with a '+' character,
then the specified algorithms will be appended to the default set instead of
replacing them. If the specified list begins with a '-' character, then the
specified algorithms (including wildcards) will be removed from the default set
instead of replacing them. If the specified list begins with a '^' character,
then the specified algorithms will be placed at the head of the default set.

The algorithms that contain Qq -etm calculate the MAC after encryption
(encrypt-then-mac). These are considered safer and their use recommended. The
supported MACs are:

B<hmac-md5> B<hmac-md5-96> B<hmac-sha1> B<hmac-sha1-96> B<hmac-sha2-256>
B<hmac-sha2-512> B<umac-64@openssh.com> B<umac-128@openssh.com>
B<hmac-md5-etm@openssh.com> B<hmac-md5-96-etm@openssh.com>
B<hmac-sha1-etm@openssh.com> B<hmac-sha1-96-etm@openssh.com>
B<hmac-sha2-256-etm@openssh.com> B<hmac-sha2-512-etm@openssh.com>
B<umac-64-etm@openssh.com> B<umac-128-etm@openssh.com>

The default is: umac-64-etm@openssh.com, umac-128-etm@openssh.com,
hmac-sha2-256-etm@openssh.com, hmac-sha2-512-etm@openssh.com,
hmac-sha1-etm@openssh.com, umac-64@openssh.com, umac-128@openssh.com,
hmac-sha2-256, hmac-sha2-512, hmac-sha1

The list of available MAC algorithms may also be obtained using Qq ssh -Q mac . I< Optional. Type uniline.  > 

=head2 Match

Introduces a conditional block. If all of the criteria on the B<Match> line are
satisfied, the keywords on the following lines override those set in the global
section of the config file, until either another B<Match> line or the end of
the file. If a keyword appears in multiple B<Match> blocks that are satisfied,
only the first instance of the keyword is applied.

The arguments to B<Match> are one or more criteria-pattern pairs or the single
token B<All> which matches all criteria. The available criteria are B<User>
B<Group> B<Host> B<LocalAddress> B<LocalPort> and B<Address>

The match patterns may consist of single entries or comma-separated lists and
may use the wildcard and negation operators described in the I<PATTERNS>
section of ssh_config5.

The patterns in an B<Address> criteria may additionally contain addresses to
match in CIDR address/masklen format, such as 192.0.2.0/24 or 2001:db8::/32.
Note that the mask length provided must be consistent with the address - it is
an error to specify a mask length that is too long for the address or one with
bits set in this host portion of the address. For example, 192.0.2.0/33 and
192.0.2.0/8, respectively.

Only a subset of keywords may be used on the lines following a B<Match>
keyword. Available keywords are B<AcceptEnv> B<AllowAgentForwarding>
B<AllowGroups> B<AllowStreamLocalForwarding> B<AllowTcpForwarding>
B<AllowUsers> B<AuthenticationMethods> B<AuthorizedKeysCommand>
B<AuthorizedKeysCommandUser> B<AuthorizedKeysFile>
B<AuthorizedPrincipalsCommand> B<AuthorizedPrincipalsCommandUser>
B<AuthorizedPrincipalsFile> B<Banner> B<CASignatureAlgorithms>
B<ChannelTimeout> B<ChrootDirectory> B<ClientAliveCountMax>
B<ClientAliveInterval> B<DenyGroups> B<DenyUsers> B<DisableForwarding>
B<ExposeAuthInfo> B<ForceCommand> B<GatewayPorts> B<GSSAPIAuthentication>
B<HostbasedAcceptedAlgorithms> B<HostbasedAuthentication>
B<HostbasedUsesNameFromPacketOnly> B<IgnoreRhosts> B<Include> B<IPQoS>
B<KbdInteractiveAuthentication> B<KerberosAuthentication> B<LogLevel>
B<MaxAuthTries> B<MaxSessions> B<PAMServiceName> B<PasswordAuthentication>
B<PermitEmptyPasswords> B<PermitListen> B<PermitOpen> B<PermitRootLogin>
B<PermitTTY> B<PermitTunnel> B<PermitUserRC> B<PubkeyAcceptedAlgorithms>
B<PubkeyAuthentication> B<PubkeyAuthOptions> B<RekeyLimit> B<RevokedKeys>
B<SetEnv> B<StreamLocalBindMask> B<StreamLocalBindUnlink> B<TrustedUserCAKeys>
B<UnusedConnectionTimeout> B<X11DisplayOffset> B<X11Forwarding> and
B<X11UseLocalhost> I< Optional. Type list of node of class L<Sshd::MatchBlock|Config::Model::models::Sshd::MatchBlock> .  > 

=head2 MaxStartups

Specifies the maximum number of concurrent unauthenticated connections to the
SSH daemon. Additional connections will be dropped until authentication
succeeds or the B<LoginGraceTime> expires for a connection. The default is
10:30:100.

Alternatively, random early drop can be enabled by specifying the three colon
separated values start:rate:full (e.g. "10:30:60"). L<sshd(8)> will refuse
connection attempts with a probability of rate/100 (30%) if there are currently
start (10) unauthenticated connections. The probability increases linearly and
all connection attempts are refused if the number of unauthenticated
connections reaches full (60). I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

10

=back



=head2 ModuliFile

Specifies the L<moduli(5)> file that contains the Diffie-Hellman groups used
for the ''diffie-hellman-group-exchange-sha1'' and
''diffie-hellman-group-exchange-sha256'' key exchange methods. The default is
/etc/ssh/moduli. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

/etc/ssh/moduli

=back



=head2 PermitUserEnvironment

Specifies whether ~/.ssh/environment and B<environment=> options in
~/.ssh/authorized_keys are processed by L<sshd(8)>. Valid options are B<yes>
B<no> or a pattern-list specifying which environment variable names to accept
(for example Qq LANG, LC_* ) . The default is B<no> Enabling environment
processing may enable users to bypass access restrictions in some
configurations using mechanisms such as B<LD_PRELOAD> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 PerSourceMaxStartups

Specifies the number of unauthenticated connections allowed from a given source
address, or ''none'' if there is no limit. This limit is applied in addition to
B<MaxStartups> whichever is lower. The default is B<none> I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

none

=back



=head2 PerSourceNetBlockSize

Specifies the number of bits of source address that are grouped together for
the purposes of applying PerSourceMaxStartups limits. Values for IPv4 and
optionally IPv6 may be specified, separated by a colon. The default is
B<32:128> which means each address is considered individually. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

32:128

=back



=head2 PerSourcePenalties

Controls penalties for various conditions that may represent attacks on
L<sshd(8)>. If a penalty is enforced against a client then its source address
and any others in the same network, as defined by B<PerSourceNetBlockSize> will
be refused connection for a period.

A penalty doesn't affect concurrent connections in progress, but multiple
penalties from the same source from concurrent connections will accumulate up
to a maximum. Conversely, penalties are not applied until a minimum threshold
time has been accumulated.

Penalties are enabled by default with the default settings listed below but may
disabled using the B<off> keyword. The defaults may be overridden by specifying
one or more of the keywords below, separated by whitespace. All keywords accept
arguments, e.g. Qq crash:2m .

B<crash:duration> Specifies how long to refuse clients that cause a crash of
L<sshd(8)>(default:90s). B<authfail:duration> Specifies how long to refuse
clients that disconnect after making one or more unsuccessful authentication
attempts (default: 5s). B<noauth:duration> Specifies how long to refuse clients
that disconnect without attempting authentication (default: 1s). This timeout
should be used cautiously otherwise it may penalise legitimate scanning tools
such as ssh-keyscan1. B<grace-exceeded:duration> Specifies how long to refuse
clients that fail to authenticate after B<LoginGraceTime> (default: 20s).
B<max:duration> Specifies the maximum time a particular source address range
will be refused access for (default: 10m). Repeated penalties will accumulate
up to this maximum. B<min:duration> Specifies the minimum penalty that must
accrue before enforcement begins (default: 15s). B<max-sources4:number ,
max-sources6:number> Specifies the maximum number of client IPv4 and IPv6
address ranges to track for penalties (default: 65536 for both).
B<overflow:mode> Controls how the server behaves when B<max-sources4> or
B<max-sources6> is exceeded. There are two operating modes: B<deny-all> which
denies all incoming connections other than those exempted via
B<PerSourcePenaltyExemptList> until a penalty expires, and B<permissive> which
allows new connections by removing existing penalties early (default:
permissive). Note that client penalties below the B<min> threshold count
against the total number of tracked penalties. IPv4 and IPv6 addresses are
tracked separately, so an overflow in one will not affect the other.
B<overflow6:mode> Allows specifying a different overflow mode for IPv6
addresses. The default it to use the same overflow mode as was specified for
IPv4. I< Optional. Type uniline.  > 

=head2 PerSourcePenaltyExemptList

Specifies a comma-separated list of addresses to exempt from penalties. This
list may contain wildcards and CIDR address/masklen ranges. Note that the mask
length provided must be consistent with the address - it is an error to specify
a mask length that is too long for the address or one with bits set in this
host portion of the address. For example, 192.0.2.0/33 and 192.0.2.0/8,
respectively. The default is not to exempt any addresses. I< Optional. Type uniline.  > 

=head2 PidFile

Specifies the file that contains the process ID of the SSH daemon, or B<none>
to not write one. The default is /run/sshd.pid. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

/run/sshd

=back



=head2 Port

Specifies the port number that L<sshd(8)> listens on. The default is 22.
Multiple options of this type are permitted. See also B<ListenAddress> I< Optional. Type uniline.  > 

=head2 PrintLastLog

Specifies whether L<sshd(8)> should print the date and time of the last user
login when a user logs in interactively. The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 PrintMotd

Specifies whether L<sshd(8)> should print /etc/motd when a user logs in
interactively. (On some systems it is also printed by the shell, /etc/profile
or equivalent.) The default is B<yes> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 RequiredRSASize

Specifies the minimum RSA key size (in bits) that L<sshd(8)> will accept. User
and host-based authentication keys smaller than this limit will be refused. The
default is B<1024> bits. Note that this limit may only be raised from the
default. I< Optional. Type integer.  > 

=over 4

=item upstream_default value :

1024

=back



=head2 SecurityKeyProvider

Specifies a path to a library that will be used when loading FIDO
authenticator-hosted keys, overriding the default of using the built-in USB HID
support. I< Optional. Type uniline.  > 

=head2 SshdSessionPath

Overrides the default path to the B<sshd-session> binary that is invoked to
handle each connection. The default is /usr/lib/openssh/sshd-session This
option is intended for use by tests. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

/usr/lib/openssh/sshd

=back



=head2 StrictModes

Specifies whether L<sshd(8)> should check file modes and ownership of the
user's files and home directory before accepting login. This is normally
desirable because novices sometimes accidentally leave their directory or files
world-writable. The default is B<yes> Note that this does not apply to
B<ChrootDirectory> whose permissions and ownership are checked unconditionally. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 Subsystem

Configures an external subsystem (e.g. file transfer daemon). Arguments should
be a subsystem name and a command (with optional arguments) to execute upon
subsystem request.

The command B<sftp-server> implements the SFTP file transfer subsystem.

Alternately the name B<internal-sftp> implements an in-process SFTP server.
This may simplify configurations using B<ChrootDirectory> to force a different
filesystem root on clients. It accepts the same command line arguments as
B<sftp-server> and even though it is in-process, settings such as B<LogLevel>
or B<SyslogFacility> do not apply to it and must be set explicitly via command
line arguments.

By default no subsystems are defined. I< Optional. Type hash of uniline.  > 

=head2 SyslogFacility

Gives the facility code that is used when logging messages from L<sshd(8)>. The
possible values are: DAEMON, USER, AUTH, LOCAL0, LOCAL1, LOCAL2, LOCAL3,
LOCAL4, LOCAL5, LOCAL6, LOCAL7. The default is AUTH. I< Optional. Type enum. choice: 'AUTH', 'DAEMON', 'LOCAL0', 'LOCAL1', 'LOCAL2', 'LOCAL3', 'LOCAL4', 'LOCAL5', 'LOCAL6', 'LOCAL7', 'USER'.  > 

=over 4

=item upstream_default value :

AUTH

=back



=head2 TCPKeepAlive

Specifies whether the system should send TCP keepalive messages to the other
side. If they are sent, death of the connection or crash of one of the machines
will be properly noticed. However, this means that connections will die if the
route is down temporarily, and some people find it annoying. On the other hand,
if TCP keepalives are not sent, sessions may hang indefinitely on the server,
leaving Qq ghost users and consuming server resources.

The default is B<yes> (to send TCP keepalive messages), and the server will
notice if the network goes down or the client host crashes. This avoids
infinitely hanging sessions.

To disable TCP keepalive messages, the value should be set to B<no>

This option was formerly called B<KeepAlive> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

yes

=back



=head2 UseDNS

Specifies whether L<sshd(8)> should look up the remote host name, and to check
that the resolved host name for the remote IP address maps back to the very
same IP address.

If this option is set to B<no> (the default) then only addresses and not host
names may be used in ~/.ssh/authorized_keys B<from> and B<sshd_config> B<Match>
B<Host> directives. I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 UsePAM

Enables the Pluggable Authentication Module interface. If set to B<yes> this
will enable PAM authentication using B<KbdInteractiveAuthentication> and
B<PasswordAuthentication> in addition to PAM account and session module
processing for all authentication types.

Because PAM keyboard-interactive authentication usually serves an equivalent
role to password authentication, you should disable either
B<PasswordAuthentication> or B<KbdInteractiveAuthentication>

If B<UsePAM> is enabled, you will not be able to run L<sshd(8)> as a non-root
user. The default is B<no> I< Optional. Type boolean.  > 

=over 4

=item upstream_default value :

no

=back



=head2 VersionAddendum

Optionally specifies additional text to append to the SSH protocol banner sent
by the server upon connection. The default is B<none> I< Optional. Type uniline.  > 

=head2 XAuthLocation

Specifies the full pathname of the L<xauth(1)> program, or B<none> to not use
one. The default is /usr/bin/xauth. I< Optional. Type uniline.  > 

=over 4

=item upstream_default value :

/usr/bin/xauth

=back



=head1 SEE ALSO

=over

=item *

L<cme>

=item *

L<Config::Model::models::Sshd::MatchBlock>

=back

=head1 LICENSE

=over

=item LGPL2


=back

=cut

